#!/usr/bin/ruby

# Implementar en este fichero la clase para crear objetos racionales

class Dieta 
    
    include Comparable
  
    
    attr_accessor :comida,:porcentaje_comida,:platos_comida,:cantidad_platos,:gr_platos,:vct,:porcentaje_proteinas,:porcentaje_grasas,:porcentaje_hidratos
    
    #FUINCION INITIALIZE
    def initialize(comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos)
        @comida=comida
        @porcentaje_comida=porcentaje_comida
        @platos_comida=platos_comida
        @cantidad_platos=cantidad_platos
        @gr_platos=gr_platos
        @vct=vct
        @porcentaje_proteinas=porcentaje_proteinas
        @porcentaje_grasas=porcentaje_grasas
        @porcentaje_hidratos=porcentaje_hidratos
    end
    
    #Trabajamos con las calorias(vct)
    def <=> other
        vct <=> other.vct
    end
  
  
    #GET COMIDA
    def get_comida
        @comida       
    end
    
    #GET PORCETAJE COMIDA
    def get_porcentaje_comida
        @porcentaje_comida
    end
    
    #GET PLATOS COMIDA
    def get_platos_comida
        @platos_comida
    end
    
    #GET CANTIDAD PALTOS
    def get_cantidad_platos
        @cantidad_platos
    end
    
    #GET GRAMOS PLATOS
    def get_gr_platos
        @gr_platos
    end
    
    #GET CALORIAS
    def get_vct
        @vct
    end
    
    #GET PORCENTAJE DE PROTEINAS
    def get_porcentaje_proteinas
        @porcentaje_proteinas
    end
    
    #GET PORCENTAJE DE GRASAS
    def get_porcentaje_grasas
        @porcentaje_grasas
    end
    
    #GET PORCENTAJE DE HIDRATOS
    def get_porcentaje_hidratos
        @porcentaje_hidratos
    end
    
    #FUNCION SORT
    def ordenacion_gr
        @gr_platos.sort
    end
    
    #TO_S
    def to_s
        s="\n#{@comida} (#{@porcentaje_comida})\n"
        (0..@platos_comida.size-1).each do |i| 
            s<< "#{@platos_comida[i]}, #{@cantidad_platos[i]}, #{@gr_platos[i]}g.\n"
        end
        s<< "VCT | %\t#{@vct} kcal | #{@porcentaje_proteinas}% - #{@porcentaje_grasas}% - #{@porcentaje_hidratos}%\n"
        s
    end
   
    
end

class GrpAlimento < Dieta


	#FUNCION INITIALIZE DE GrpAlimento
	def initialize(comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos,alimento)
		super(comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos)
		@alimento = alimento
	end
	
	#GET ALIMENTO
	def get_alimento
		@alimento
	end
	
	#TO_S
	def to_s
		aux = "#{@alimento}\n"
		super.to_s += aux
	end
end


class GrpEdad < Dieta


	#FUNCION INITIALIZE DE GrpEdad
	def initialize(comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos,edad)
		super(comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos)
		@edad = edad
	end
	
	#GET EDAD
	def get_edad
		@edad
	end
	
	#TO_S
	def to_s
		aux = "#{@edad}\n"
		super.to_s += aux
	end
end

