class Dietadsl
  attr_accessor :title, :ingesta_diaria, :platos, :instructions, :porcent, :atributo
  def initialize(&block)
    self.title = ""
    self.ingesta_diaria= []
    self.porcent= []
    self.platos = []
    self.instructions = []
    self.atributo= ""

    if block_given?  
      if block.arity == 1
        yield self
      else
       instance_eval(&block) 
      end
    end
  end
  
    def to_s
    
        if atributo != ""
          output = atributo + "\n"
        else
          output=atributo
        end
        output << title
        output << " #{ingesta_diaria.join()}"
        #output << "\n#{'=' * titulo.size}\n\n"
        output << "\n#{platos.join()}"
        output << "#{porcent.join()}"
    
        output
    end
    
  def titulo (text)
    titulo = text
    title << titulo
  end
  
  def grupo (text)
    grupo = text
    atributo << grupo
  end
  
  def ingesta (options = {})
    ingesta = " ("
    ingesta << "#{options[:min]} " if options[:min]
    ingesta << "- #{options[:max]}" if options[:max]
    ingesta << "%)"
    ingesta_diaria << ingesta
  end
  
  def plato(options = {})
    plato = ""
    plato << "- #{options[:descripcion]}," if options[:descripcion]
    plato << " #{options[:porcion]}," if options[:porcion]
    plato << " #{options[:gramos]} g" if options[:gramos]
    plato << " #{options[:mlitros]} ml" if options[:mlitros]
    plato << "\n"
    platos << plato
  end

  def porcentajes(options = {})
    porcentajes = ""
    porcentajes << "V.C.T | %    #{options[:vct]} kcal | " if options[:vct]
    porcentajes << "#{options[:proteinas]}% - " if options[:proteinas]
    porcentajes << "#{options[:grasas]}% - " if options[:grasas]
    porcentajes << "#{options[:hidratos]}%" if options[:hidratos]
    porcent << porcentajes
    
  end
end