#CLASE NODE
Node = Struct.new(:value,:next,:prev)

#CLASE LISTA
class Lista
    
    #MODULO ENUMERABLE
    include Enumerable 
    attr_reader :inicio,:fin
    
    #FUNCION INITIALIZE
    def initialize()
        @inicio = nil
        @fin = nil
    end
    
    #EMPTY : COMPUREBA QUE LA LISTA ESTA VACIA
    def empty
        if (@inicio == nil)
            return true
        else 
            return false
        end
    end
    
    #INSERTAR INICIO
    def insertar_i(valor)
        aux = Node.new(valor,@inicio,nil)
        @inicio = aux #aux pasa a ser el nuevo inicio

        if(empty)
            @fin = @inicio
        end
        
        return @inicio.value             
    end
    
    #INSERTAR FINAL
    def insertar_f(valor)
        aux = Node.new(valor,nil,@fin)
        @fin = aux
        if(empty)
            @inicio = @fin
        end
            
        return @fin.value 
        
    end
    
    #INSERTAR VARIOS
    def insertar_n(vector)
        
        count = 0
        for i in vector
         insertar_i(i)
         count = count + 1
        end
        return count
        
    end
    
    #EXTRAER INICIO
    def extraer_i  #extraemos del principio
        
        if (empty)
            puts "lista vacia"
            return false
        else
            aux = @inicio
            @inicio = @inicio.next
            #@inicio.prev = nil
            return aux.value
        end
        
    end
    
    #EXTRAER FINAL
    def extraer_f
        if (empty)
            puts "lista vacia"
            return false
        else
            aux = @fin
            @fin = @fin.prev
            #@fin.next = nil
            return aux.value
        end
           
    end    
    
    #METODO EACH
    def each
      		nodo = @inicio
      		while(nodo != nil)
      			yield nodo.value
      			nodo = nodo.next
      		end
    end 
    
    
end